Attribute VB_Name = "ReadRegistry"
Option Explicit

Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hkey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hkey As Long) As Long
Private Declare Function RegQueryValueExS Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hkey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegSetValueExS Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hkey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long


Sub ReadRegistry()
  ' ActiveCell.Value = GetRegString(&H80000002, "SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
  ActiveCell.Value = GetRegString(&H80000002, "SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "Personal")
End Sub


Public Function GetRegString(ByVal HomeKey As Long, ByVal KeyName As String, ByVal ValueName As String) As String
  Dim hkey As Long      'Handle  
  Dim sData As String   '   
  Dim lres As Long      '  API 
  Dim lDataType As Long '  
  Dim lDlen As Long     '    
  Dim p As Integer      '     
  lres = RegOpenKey(HomeKey, KeyName, hkey) ' 
  If lres <> 0 Then '    - , 
    GetRegString = ""
    Exit Function
  End If
  sData = String$(255, 32) & Chr$(0) ',   .
  lDlen = Len(sData)
  lres = RegQueryValueExS(hkey, ValueName, 0, lDataType, sData, lDlen) ' 
  If lres <> 0 Then '    - , 
    GetRegString = ""
    Exit Function
  End If
  If lDataType = 1 Or lDataType = 2 Then ' REG_SZ, REG_EXPAND_SZ - Unicode nul terminated string
    GetRegString = Left$(sData, lDlen - 1)
  ElseIf lDataType = 7 Then ' REG_MULTI_SZ - Multiple Unicode Strings
    For p = lDlen To 1 Step -1 '   - 
      If Mid(sData, p, 1) <> Chr(0) Then Exit For
    Next
    sData = Mid(sData, 1, p)
    GetRegString = Replace(sData, Chr(0), Chr(10)) '     
  Else
    GetRegString = "" '        :(
  End If
  lres = RegCloseKey(hkey) '  
End Function

